	.module NetBarometer.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.area data(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
_NetBroadCast::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbsym e NetBroadCast _NetBroadCast C
_BaroError::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbsym e BaroError _BaroError c
_HumiError::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbsym e HumiError _HumiError c
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbfunc e main _main fV
	.even
_main::
	sbiw R28,1
	.dbline -1
	.dbline 238
; //*****************************************************************************
; // NetBarometer
; // Version 10.0 Nov 2005
; //
; // 10.0 -> New code for 9bit protocol
; // 10.1 -> Bug Code jam is error on SHT75 is corrected
; //
; // Sylvain Bissonnette
; //*****************************************************************************
; //
; //						        R E T U R N   S T A C K   6 4
; //						  	            X T A L  16 MHZ
; //						          BootLoader of 512 word
; //
; //*****************************************************************************
; //
; //							            F U S E   B I T
; //
; //( )7      ( )6     (X)BL12 (X)BL11  ( )BL02   ( )BL01    ( )Lock2   ( )Lock1
; //( )RSTDIS ( )WDON  (X)SPIEN(X)CKOPT (X)EESAVE (X)BOOTSZ1 ( )BOOTSZ0 (X)BOOTRST
; //(X)BODLEV (X)BODEN ( )SUT1 ( )SUT0  ( )CKSEL3 ( )CKSEL2  ( )CKSEL1  ( )CKSEL0
; //
; //*****************************************************************************
; //								        P I N   U S A G E
; //
; // PB0 -> n/c
; // PB1 -> MCLK
; // PB2 -> n/c
; // PB3 -> n/c
; // PB4 -> HUMIDITY_DATA
; // PB5 -> HUMIDITY_SCK
; // PB6 -> XTAL
; // PB7 -> XTAL
; //
; // PC0 -> DIP SW0
; // PC1 -> DIP SW1
; // PC2 -> DIP SW2
; // PC3 -> DIP SW3
; // PC4 -> DIP SW4
; // PC5 -> DIP SW5
; // PC6 -> RESET
; //
; // PD0 -> RS485 RX
; // PD1 -> RS485 TX
; // PD2 -> RS485 TXE
; // PD3 -> LED	
; // PD4 -> n/c
; // PD5 -> BAROMETER_DIN
; // PD6 -> BAROMETER_DOUT
; // PD7 -> BAROMETER_SCLK
; //
; // ADC6-> n/c
; // ADC7-> n/c
; //
; //*****************************************************************************
; //								T I M E R   U S A G E
; //
; // Timer 0 is use by taskmanager
; // Timer 1 is use by Barometer for 32khz
; //
; // NetWork Function
; //-----------------------------------------------------------------------------
; // Command 
; // 0xff           -> Get 16 bit software version
; // 0xf5,0x55,0xaa -> Reset MCU
; // 0xf0,0x55,L,V  -> Write eeprom at L value V
; // 0xf1,0x55,L	  -> Read eeprom at L 
; // 0x20	   		    -> Get 16 bit Temperature * 10
; // 0x21	   		    -> Get 16 bit Humidity * 10
; // 0x22	   		    -> Get 16 bit Pressure * 10
; //-----------------------------------------------------------------------------
; // EEprom
; // 00    -> Not for use
; // 01@xx -> Free
; //*****************************************************************************
; // return 44330.7692 * (1 - pow(pressure / 101.325, 0.190255));   // Meters
; // return 174530.2383 * (1 - pow(pressure / 101.325, 0.190255));  // Feet
; //
; //*****************************************************************************
; //            					I N C L U D E
; //*****************************************************************************
; #include <iom8v.h>
; #include <macros.h>
; #include <stdlib.h>
; #include <eeprom.h>
; #include "TaskManager.h"
; #include <shortnametype.h>
; 
; //*****************************************************************************
; //            					D E F I N E
; //*****************************************************************************
; #define VERSION		        	    101
; #define DEVICE                  80
; #define TRUE		        	      1
; #define FALSE					          0
; #define XTAL					          16000000
; #define ACK   					        1
; #define noACK 					        0
; 
; #define BAROMETER_DDR			      DDRD
; #define BAROMETER_PIN			      PIND
; #define BAROMETER_PORT			    PORTD
; #define BAROMETER_DOUT			    0x40
; #define BAROMETER_DIN			      0x20
; #define BAROMETER_SCLK			    0x80
; #define BAROMETER_CLK			      0x02
; #define BAROMETER32K_DDR        DDRB
; #define BAROMETER32K_PIN        PINB
; #define BAROMETER32K_PORT       PORTB
; #define BAROMETER32K_CLK        0x02
; 
; #define HUMIDITY_DDR			      DDRB
; #define HUMIDITY_PIN			      PINB
; #define HUMIDITY_PORT			      PORTB
; #define HUMIDITY_DATA			      0x10
; #define HUMIDITY_SCK			      0x20
;                             	          //adr    command r/w
; #define HUMIDITY_STATUS_REG_W 	0x06    //000   	0011    0
; #define HUMIDITY_STATUS_REG_R 	0x07    //000   	0011    1
; #define HUMIDITY_MEASURE_TEMP 	0x03    //000   	0001    1
; #define HUMIDITY_MEASURE_HUMI 	0x05    //000   	0010    1
; #define HUMIDITY_RESET    		  0x1e    //000   	1111    0
; 
; #define LED_DDR					        DDRD
; #define LED_PIN					        PIND
; #define LED_PORT				        PORTD
; #define LED						          0x08
; 
; #define NET_ADDRESS_DDR         DDRC
; #define NET_ADDRESS_PIN         PINC
; #define NET_ADDRESS_PORT        PORTC
; 
; #define NET_DDR					        DDRD
; #define NET_PIN					        PIND
; #define NET_PORT				        PORTD
; #define NET_RX					        0x01
; #define NET_TX					        0x02
; #define NET_TXE					        0x04
; 
; #define NET_UBRRH 				      UBRRH
; #define NET_UBRRL				        UBRRL		
; #define NET_UCSRA 				      UCSRA
; #define NET_UCSRB 				      UCSRB
; #define NET_UCSRC 				      UCSRC 
; #define NET_UDR					        UDR
; 
; #define NET_RXBUFFER			      10
; #define NET_TXBUFFER			      10
; 
; #define NET_GET_ADDRESS			    (NET_ADDRESS_PIN & 0x3f) + 64;
; 
; #define NET_SPEED				        19200
; 
; #define BROADCASTDEVTYPE		    0xf1
; #define BROADCAST   			      0xff
; 
; //*****************************************************************************
; //          				P R O T O T Y P E
; //*****************************************************************************
; void main(void);
; void _StackOverflowed(char c);
; 
; void LEDInit(void);
; void LEDFlash(void);
; 
; void HumidityInit(void);
; void HumidityDelay(void);
; void HumidityWriteByte(ushort value);
; ushort HumidityReadByte(ushort ack);
; void HumidityTransStart(void);
; void HumidityConnectionReset(void);
; void HumiditySoftReset(void);
; ushort HumidityReadStatus(void);
; void HumidityWriteStatus(ushort value);
; uint HumidityMeasure(ushort mode);
; void HumidityCalc(float *p_humidity ,float *p_temperature);
; void HumidityGet(float *p_humidity ,float *p_temperature);
; void HumidityUpdate(void);
; 
; void BarometerInit(void);
; void BarometerUpdate(void);
; void BarometerCalcPT5534( float *pressure,
; 	 					              float *temperature,
; 						              uint d1_arg,
; 						              uint d2_arg);
; uint BarometerConvertWtoC5534(ushort ix,
; 		 	 						                    uint W1,
; 									                    uint W2,
; 									                    uint W3,
; 									                    uint W4);
; uint BarometerGetD1(void);
; uint BarometerGetD2(void);
; uint BarometerGetW(ushort index);
; void BarometerReset(void);
; uint BarometerGet16(void);
; void BarometerSendLsbFirst(char pattern, char nbr_clock);
; ushort BarometerWaitOnDoutFall(void);
; void BarometerSetSCLK(ushort state);
; ushort BarometerGetSCLK(void);
; void BarometerSetDIN(ushort state);
; ushort BarometerGetDIN(void);
; ushort BarometerGetDOUT(void);
; void   BarometerWaitOnePulse(void);
; 
; void NetInit(void);
; void NetRxChar(void);
; void NetAnalyseData(void);
; void NetWrite(int Value);
; void NetTxByte(void);
; void NetTxFinish(void);
; void NetGetAddress(void);
; 
; //*****************************************************************************
; //   					G L O B A L   V A R I A B L E
; //*****************************************************************************
; ushort NetAddress;
; ushort NetRxData[NET_RXBUFFER];
; ushort NetTxData[NET_TXBUFFER];
; ushort *NetTxPtr;
; short NetTxQte;
; short NetBroadCast = FALSE;
; 
; ushort NetNextEventTime;
; void (*NetNextFunction)(void);
; 
; ushort BaroError = FALSE;
; ushort HumiError = FALSE;
; uint fc[6];
; 
; uint Temp,Hum,Pres;
; 
; float Pressure,BaroTemp,Temperature,Humidity;
; 
; //*****************************************************************************
; //            					M A I N
; //*****************************************************************************
; void main()
; {
	.dbline 239
;   WDR();
	wdr
	.dbline 240
;   WDTCR = 0x0f;			// Enable WatchDog at 2.2 sec
	ldi R24,15
	out 0x21,R24
	.dbline 242
; 
;   TaskInit();
	rcall _TaskInit
	.dbline 243
;   NetInit();
	rcall _NetInit
	.dbline 244
;   BarometerInit();
	rcall _BarometerInit
	.dbline 245
;   HumidityInit();
	rcall _HumidityInit
	.dbline 246
;   LEDInit();
	rcall _LEDInit
	.dbline 247
;   SEI();
	sei
	.dbline 249
; 
;   TaskRegister(LEDFlash,T500MS,TRUE);
	ldi R24,1
	std y+0,R24
	ldi R18,5000
	ldi R19,19
	ldi R16,<PL_LEDFlash
	ldi R17,>PL_LEDFlash
	rcall _TaskRegister
	rjmp L3
L2:
	.dbline 252
; 
;   while (1) 
;   {
	.dbline 253
;     WDR();
	wdr
	.dbline 254
;     _StackCheck();
	rcall __StackCheck
	.dbline 255
;     NetGetAddress();
	rcall _NetGetAddress
	.dbline 256
;     BarometerUpdate();
	rcall _BarometerUpdate
	.dbline 257
;     HumidityUpdate();
	rcall _HumidityUpdate
	.dbline 258
;   }
L3:
	.dbline 251
	rjmp L2
X0:
	.dbline -2
L1:
	.dbline 0 ; func end
	adiw R28,1
	ret
	.dbend
	.dbfunc e _StackOverflowed __StackOverflowed fV
;              c -> <dead>
	.even
__StackOverflowed::
	st -y,r17
	st -y,r16
	.dbline -1
	.dbline 276
; }
; 
; /******************************************************************************
; 
; Name:			    void _StackOverflowed(char c)
; 
; Description:	This function is automaticaly called if
;               the stack crash, PD7 will be set.
; 
; 
; Input:			  none
; 
; Output:			  PD7
; 
; Misc:
; ******************************************************************************/
; void _StackOverflowed(char c)
; {
	.dbline 277
;   CLI();
	cli
L6:
	.dbline 278
;   while(1);
L7:
	.dbline 278
	rjmp L6
X1:
	.dbline -2
L5:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l c 0 c
	.dbend
	.dbfunc e LEDInit _LEDInit fV
	.even
_LEDInit::
	.dbline -1
	.dbline 295
; }
; 
; /******************************************************************************
; 
; Name:			    void LEDInit(void)
; 
; Description:	Init device for LED
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; 
; ******************************************************************************/
; void LEDInit(void)
; {
	.dbline 296
;   LED_DDR |= LED;			// Pin as output
	sbi 0x11,3
	.dbline -2
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LEDFlash _LEDFlash fV
	.even
_LEDFlash::
	.dbline -1
	.dbline 312
; }
; 
; /******************************************************************************
; 
; Name:			    void LEDFlash(void)
; 
; Description:	This function make the LED Flashing
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void LEDFlash(void)
; {
	.dbline 313
;   CLI();
	cli
	.dbline 314
;   LED_PORT ^= LED;
	ldi R24,8
	in R2,0x12
	eor R2,R24
	out 0x12,R2
	.dbline 315
;   SEI();
	sei
	.dbline -2
L10:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e HumidityDelay _HumidityDelay fV
;              i -> R16,R17
	.even
_HumidityDelay::
	.dbline -1
	.dbline 335
; }
; 
; //*****************************************************************************
; //     H U M I D I T Y  & T E M P    F U N C T I O N
; //*****************************************************************************
; /******************************************************************************
; 
; Name:			    void HumidityDelay(void)
; 
; Description:	Delay for SCLK
; 
; Input:			  none
; 
; Output:			  none
; 
; 
; Misc:
; ******************************************************************************/
; void HumidityDelay(void)
; {
	.dbline 338
;   int i;
; 
;   for (i=0;i<(XTAL/400000);i++) WDR();
	clr R16
	clr R17
	rjmp L15
L12:
	.dbline 338
	wdr
L13:
	.dbline 338
	subi R16,255  ; offset = 1
	sbci R17,255
L15:
	.dbline 338
	ldi R24,40
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brlt L12
X2:
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbsym r i 16 I
	.dbend
	.dbfunc e HumidityInit _HumidityInit fV
	.even
_HumidityInit::
	.dbline -1
	.dbline 356
; }
; 
; /******************************************************************************
; 
; Name:			    void HumidityInit(void)
; 
; Description:	Initialise port and constant used by
;               the Humidity & Temp hardware
; 
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void HumidityInit(void)
; {
	.dbline 357
;   HUMIDITY_DDR |= HUMIDITY_DATA + HUMIDITY_SCK;
	in R24,0x17
	ori R24,48
	out 0x17,R24
	.dbline 358
;   HUMIDITY_PORT |= HUMIDITY_DATA + HUMIDITY_SCK;
	in R24,0x18
	ori R24,48
	out 0x18,R24
	.dbline 359
;   HumiditySoftReset();
	rcall _HumiditySoftReset
	.dbline -2
L16:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e HumidityWriteByte _HumidityWriteByte fV
;              i -> R20
;          value -> R10
	.even
_HumidityWriteByte::
	st -y,R10
	st -y,R20
	mov R10,R16
	.dbline -1
	.dbline 377
; }
; 
; /******************************************************************************
; 
; Name:			    ushort HumidityWriteByte(ushort value)
; 
; Description:	writes a byte on the Sensibus and
;               checks the acknowledge
; 
; Input:			  ushort value -> byte to write
; 
; Output:			  none
; 
; 
; Misc:			    If the device don't ACK set HumiError to TRUE;
; ******************************************************************************/
; void HumidityWriteByte(ushort value)
; {
	.dbline 380
;   ushort i;
; 
;   HUMIDITY_DDR  |= HUMIDITY_DATA;       //DATA-line in output
	sbi 0x17,4
	.dbline 382
; 
;   for (i=0x80;i>0;i/=2)                 //shift bit for masking
	ldi R20,128
	rjmp L21
L18:
	.dbline 383
;   {
	.dbline 384
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 385
;     if (i & value) HUMIDITY_PORT |= HUMIDITY_DATA;
	mov R2,R20
	and R2,R10
	breq L22
X3:
	.dbline 385
	sbi 0x18,4
	rjmp L23
L22:
	.dbline 386
;     else HUMIDITY_PORT &= ~HUMIDITY_DATA;
	cbi 0x18,4
L23:
	.dbline 387
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 388
;     HUMIDITY_PORT |= HUMIDITY_SCK;
	sbi 0x18,5
	.dbline 389
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 390
;     HUMIDITY_PORT &= ~HUMIDITY_SCK;
	cbi 0x18,5
	.dbline 391
;   }
L19:
	.dbline 382
	lsr R20
L21:
	.dbline 382
	ldi R24,0
	cp R24,R20
	brlo L18
X4:
	.dbline 393
; 
;   HUMIDITY_PORT |= HUMIDITY_DATA;       //release DATA-line
	sbi 0x18,4
	.dbline 394
;   HUMIDITY_DDR  &= ~HUMIDITY_DATA;	    //DATA-line in input
	cbi 0x17,4
	.dbline 395
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 396
;   HUMIDITY_PORT |= HUMIDITY_SCK;	      //clk #9 for ack
	sbi 0x18,5
	.dbline 397
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 398
;   if (HUMIDITY_PIN & HUMIDITY_DATA) HumiError = TRUE;
	sbis 0x16,4
	rjmp L24
X5:
	.dbline 398
	ldi R24,1
	sts _HumiError,R24
L24:
	.dbline 399
;   HUMIDITY_PORT &= ~HUMIDITY_SCK;
	cbi 0x18,5
	.dbline 400
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline -2
L17:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r i 20 c
	.dbsym r value 10 c
	.dbend
	.dbfunc e HumidityReadByte _HumidityReadByte fc
;            val -> R10
;              i -> R22
;            ack -> R20
	.even
_HumidityReadByte::
	rcall push_xgsetF00C
	mov R20,R16
	.dbline -1
	.dbline 417
; }
; 
; /******************************************************************************
; 
; Name:			    ushort HumidityReadByte(ushort ack)
; 
; Description:	reads a byte form the Sensibus and gives
;               an acknowledge in case of "ack=1"
; 
; Input:			  ushort ack -> ack status
; 
; Output:			  ushort value readed
; 
; Misc:
; ******************************************************************************/
; ushort HumidityReadByte(ushort ack)
; {
	.dbline 418
;   ushort i,val=0;
	clr R10
	.dbline 420
; 
;   HUMIDITY_PORT |= HUMIDITY_DATA;       //release DATA-line
	sbi 0x18,4
	.dbline 421
;   HUMIDITY_DDR  &= ~HUMIDITY_DATA;	    //DATA-line in input
	cbi 0x17,4
	.dbline 423
; 
;   for (i=0x80;i>0;i/=2)                 //shift bit for masking
	ldi R22,128
	rjmp L30
L27:
	.dbline 424
;   {
	.dbline 425
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 426
;     HUMIDITY_PORT |= HUMIDITY_SCK;      //clk for SENSI-BUS
	sbi 0x18,5
	.dbline 427
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 428
;     if (HUMIDITY_PIN & HUMIDITY_DATA) val=(val | i);  //read bit
	sbis 0x16,4
	rjmp L31
X6:
	.dbline 428
	or R10,R22
L31:
	.dbline 429
;     HUMIDITY_PORT &= ~HUMIDITY_SCK;
	cbi 0x18,5
	.dbline 430
;   }
L28:
	.dbline 423
	lsr R22
L30:
	.dbline 423
	ldi R24,0
	cp R24,R22
	brlo L27
X7:
	.dbline 432
; 
;   if (ack == 1)
	cpi R20,1
	brne L33
X8:
	.dbline 433
;   {
	.dbline 434
;     HUMIDITY_DDR  |= HUMIDITY_DATA;	    //DATA-line in output
	sbi 0x17,4
	.dbline 435
;     HUMIDITY_PORT &= ~HUMIDITY_DATA;    //"ack==1" pull down DATA-Line
	cbi 0x18,4
	.dbline 436
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 437
;     HUMIDITY_PORT |= HUMIDITY_SCK;
	sbi 0x18,5
	.dbline 438
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 439
;     HUMIDITY_PORT &= ~HUMIDITY_SCK;
	cbi 0x18,5
	.dbline 440
;   }
	rjmp L34
L33:
	.dbline 442
;   else
;   {
	.dbline 443
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 444
;     HUMIDITY_PORT |= HUMIDITY_SCK;
	sbi 0x18,5
	.dbline 445
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 446
;     HUMIDITY_PORT &= ~HUMIDITY_SCK;
	cbi 0x18,5
	.dbline 447
;   }
L34:
	.dbline 448
;   return val;
	mov R16,R10
	.dbline -2
L26:
	.dbline 0 ; func end
	rjmp pop_xgsetF00C
	.dbsym r val 10 c
	.dbsym r i 22 c
	.dbsym r ack 20 c
	.dbend
	.dbfunc e HumidityTransStart _HumidityTransStart fV
	.even
_HumidityTransStart::
	.dbline -1
	.dbline 468
; }
; 
; /******************************************************************************
; 
; Name:			    ushort HumidityTransStart(void)
; 
; Description:	Generates a transmission start
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
;               _____         ________
; DATA:              |_______|
;                   ___     ___
; SCK :         ___|   |___|   |______
; ******************************************************************************/
; void HumidityTransStart(void)
; {
	.dbline 469
;   HUMIDITY_DDR  |= HUMIDITY_DATA;       //DATA-line in output
	sbi 0x17,4
	.dbline 471
; 
;   HUMIDITY_PORT |= HUMIDITY_DATA;       //DATA=1
	sbi 0x18,4
	.dbline 472
;   HUMIDITY_PORT &= ~HUMIDITY_SCK;  	    //SCK=0
	cbi 0x18,5
	.dbline 473
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 474
;   HUMIDITY_PORT |= HUMIDITY_SCK;  	    //SCK=1
	sbi 0x18,5
	.dbline 475
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 476
;   HUMIDITY_PORT &= ~HUMIDITY_DATA; 	    //DATA=0
	cbi 0x18,4
	.dbline 477
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 478
;   HUMIDITY_PORT &= ~HUMIDITY_SCK; 	    //SCK=0
	cbi 0x18,5
	.dbline 479
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 480
;   HUMIDITY_PORT |= HUMIDITY_SCK; 		    //SCK=1
	sbi 0x18,5
	.dbline 481
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 482
;   HUMIDITY_PORT |= HUMIDITY_DATA;		    //DATA=1
	sbi 0x18,4
	.dbline 483
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline 484
;   HUMIDITY_PORT &= ~HUMIDITY_SCK;		    //SCK=0
	cbi 0x18,5
	.dbline 485
;   HumidityDelay();
	rcall _HumidityDelay
	.dbline -2
L35:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e HumidityConnectionReset _HumidityConnectionReset fV
;              i -> R20
	.even
_HumidityConnectionReset::
	st -y,R20
	.dbline -1
	.dbline 506
; }
; 
; /******************************************************************************
; 
; Name:			    void HumidityConnectionReset(void)
; 
; Description:	communication Reset: DATA-line=1 and at
;               least 9 SCK cycles followed by transstart
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
;               _____________________________________________________         ________
; DATA:                                                              |_______|
;                  _    _    _    _    _    _    _    _    _        ___     ___
; SCK :         __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |______
; ******************************************************************************/
; void HumidityConnectionReset(void)
; {
	.dbline 509
;   ushort i;
; 
;   HUMIDITY_DDR  |= HUMIDITY_DATA;           //DATA-line in output
	sbi 0x17,4
	.dbline 510
;   HUMIDITY_PORT |= HUMIDITY_DATA;           //DATA=1
	sbi 0x18,4
	.dbline 511
;   HUMIDITY_PORT &= ~HUMIDITY_SCK;  	        //SCK=0
	cbi 0x18,5
	.dbline 513
; 
;   for (i=0;i<9;i++)                         //9 SCK cycles
	clr R20
	rjmp L40
L37:
	.dbline 514
;   {
	.dbline 515
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 516
;     HUMIDITY_PORT |= HUMIDITY_SCK; 		      //SCK=1
	sbi 0x18,5
	.dbline 517
;     HumidityDelay();
	rcall _HumidityDelay
	.dbline 518
;     HUMIDITY_PORT &= ~HUMIDITY_SCK; 	      //SCK=0
	cbi 0x18,5
	.dbline 519
;   }
L38:
	.dbline 513
	inc R20
L40:
	.dbline 513
	cpi R20,9
	brlo L37
X9:
	.dbline 520
;   HumidityTransStart();                     //transmission start
	rcall _HumidityTransStart
	.dbline 521
;   HumiError = FALSE;
	clr R2
	sts _HumiError,R2
	.dbline -2
L36:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e HumiditySoftReset _HumiditySoftReset fV
;              i -> R20,R21
	.even
_HumiditySoftReset::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 538
; }
; 
; /******************************************************************************
; 
; Name:			    void HumiditySoftReset(void)
; 
; Description:	Resets the sensor by a softReset
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; 
; ******************************************************************************/
; void HumiditySoftReset(void)
; {
	.dbline 540
;   int i;
;   HumidityConnectionReset();           //Reset communication
	rcall _HumidityConnectionReset
	.dbline 541
;   HumidityWriteByte(HUMIDITY_RESET);   //send Reset-command to sensor
	ldi R16,30
	rcall _HumidityWriteByte
	.dbline 542
;   for (i=0;i<100;i++) HumidityDelay(); // 11ms delay
	clr R20
	clr R21
L42:
	.dbline 542
	rcall _HumidityDelay
L43:
	.dbline 542
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 542
	cpi R20,100
	ldi R30,0
	cpc R21,R30
	brlt L42
X10:
	.dbline -2
L41:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r i 20 I
	.dbend
	.dbfunc e HumidityReadStatus _HumidityReadStatus fc
;          value -> R10
	.even
_HumidityReadStatus::
	st -y,R10
	.dbline -1
	.dbline 559
; }
; 
; /******************************************************************************
; 
; Name:			    ushort HumidityReadStatus(void)
; 
; Description:	reads the status register with checksum (8-bit)
; 
; Input:			  none
; 
; Output:			  ushort status byte
; 
; Misc:
; 
; ******************************************************************************/
; ushort HumidityReadStatus(void)
; {
	.dbline 562
;   ushort value;
; 
;   HumidityTransStart();                     //transmission start
	rcall _HumidityTransStart
	.dbline 563
;   HumidityWriteByte(HUMIDITY_STATUS_REG_R); //send command to sensor
	ldi R16,7
	rcall _HumidityWriteByte
	.dbline 564
;   value = HumidityReadByte(ACK);            //read status register (8-bit)
	ldi R16,1
	rcall _HumidityReadByte
	mov R10,R16
	.dbline 565
;   HumidityReadByte(noACK);    		      //dummy read checksum (8-bit)
	clr R16
	rcall _HumidityReadByte
	.dbline 566
;   return value;
	mov R16,R10
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r value 10 c
	.dbend
	.dbfunc e HumidityWriteStatus _HumidityWriteStatus fV
;          value -> R10
	.even
_HumidityWriteStatus::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 583
; }
; 
; /******************************************************************************
; 
; Name:			    void HumidityWriteStatus(ushort value)
; 
; Description:	writes the status register with checksum (8-bit)
; 
; Input:			  ushort value to write in the status register
; 
; Output:			  none
; 
; Misc:
; 
; ******************************************************************************/
; void HumidityWriteStatus(ushort value)
; {
	.dbline 584
;   HumidityTransStart();                       //transmission start
	rcall _HumidityTransStart
	.dbline 585
;   HumidityWriteByte(HUMIDITY_STATUS_REG_W);   //send command to sensor
	ldi R16,6
	rcall _HumidityWriteByte
	.dbline 586
;   HumidityWriteByte(value);    		            //send value of status register
	mov R16,R10
	rcall _HumidityWriteByte
	.dbline -2
L47:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r value 10 c
	.dbend
	.dbfunc e HumidityMeasure _HumidityMeasure fi
;            lsb -> R12
;            msb -> R10
;              i -> R20,R21
;              j -> R22,R23
;           mode -> R10
	.even
_HumidityMeasure::
	rcall push_xgsetF03C
	mov R10,R16
	.dbline -1
	.dbline 603
; }
; 
; /******************************************************************************
; 
; Name:			    uint HumidityMeasure(ushort mode)
; 
; Description:	makes a measurement (humidity/temperature)
; 
; Input:			  mode -> HUMI or TEMP
; 
; Output:			  uint Value mesured
; 
; Misc:
; 
; ******************************************************************************/
; uint HumidityMeasure(ushort mode)
; {
	.dbline 607
;   ushort msb,lsb;
;   uint i,j;
; 
;   HumidityTransStart();                     //transmission start
	rcall _HumidityTransStart
	.dbline 608
;   switch (mode)							                //send command to sensor
	mov R20,R10
	clr R21
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	breq L52
X11:
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	breq L53
X12:
	rjmp L50
L52:
	.dbline 610
;   {
;     case HUMIDITY_MEASURE_TEMP : HumidityWriteByte(HUMIDITY_MEASURE_TEMP);
	ldi R16,3
	rcall _HumidityWriteByte
	.dbline 611
;     break;
	rjmp L50
L53:
	.dbline 612
;     case HUMIDITY_MEASURE_HUMI : HumidityWriteByte(HUMIDITY_MEASURE_HUMI);
	ldi R16,5
	rcall _HumidityWriteByte
	.dbline 613
;     break;
	.dbline 614
;     default     : break;
L50:
	.dbline 617
;   }
; 
;   HUMIDITY_PORT |= HUMIDITY_DATA;           //release DATA-line
	sbi 0x18,4
	.dbline 618
;   HUMIDITY_DDR  &= ~HUMIDITY_DATA;	        //DATA-line in input
	cbi 0x17,4
	.dbline 620
; 
;   for (i=0;i<=65530;i++)
	clr R20
	clr R21
	rjmp L57
L54:
	.dbline 621
;   {
	.dbline 622
;     for (j=0;j<10;j++) WDR();
	clr R22
	clr R23
	rjmp L61
L58:
	.dbline 622
	wdr
L59:
	.dbline 622
	subi R22,255  ; offset = 1
	sbci R23,255
L61:
	.dbline 622
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	brlo L58
X13:
	.dbline 623
;     if((HUMIDITY_PIN & HUMIDITY_DATA) == 0) break; //wait until sensor
	sbic 0x16,4
	rjmp L62
X14:
	.dbline 623
	rjmp L56
L62:
	.dbline 624
;   }				   				  	 		                //has finished the measure
L55:
	.dbline 620
	subi R20,255  ; offset = 1
	sbci R21,255
L57:
	.dbline 620
	ldi R24,250
	ldi R25,255
	ldi R26,0
	ldi R27,0
	movw R2,R20
	clr R4
	clr R5
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brge L54
X15:
L56:
	.dbline 625
;   if(i > 65520)
	ldi R24,240
	ldi R25,255
	ldi R26,0
	ldi R27,0
	movw R2,R20
	clr R4
	clr R5
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brge L64
X16:
	.dbline 626
;   {
	.dbline 627
;     HumiError=1;                            // or timeout (~2 sec.) is reached
	ldi R24,1
	sts _HumiError,R24
	.dbline 628
;     return 0xffff;
	ldi R16,65535
	ldi R17,255
	rjmp L48
L64:
	.dbline 631
;   }
; 
;   msb  =HumidityReadByte(ACK);              //read the first byte (MSB)
	ldi R16,1
	rcall _HumidityReadByte
	mov R10,R16
	.dbline 632
;   lsb=HumidityReadByte(ACK);                //read the second byte (LSB)
	ldi R16,1
	rcall _HumidityReadByte
	mov R12,R16
	.dbline 633
;   HumidityReadByte(noACK);             //dummy read checksum
	clr R16
	rcall _HumidityReadByte
	.dbline 634
;   return (msb<<8)+lsb;
	mov R17,R10
	mov R16,R12
	.dbline -2
L48:
	.dbline 0 ; func end
	rjmp pop_xgsetF03C
	.dbsym r lsb 12 c
	.dbsym r msb 10 c
	.dbsym r i 20 i
	.dbsym r j 22 i
	.dbsym r mode 10 c
	.dbend
	.dbfunc e HumidityCalc _HumidityCalc fV
;         rh_lin -> y+36
;              t -> y+32
;             T2 -> y+28
;             T1 -> y+24
;             C3 -> y+20
;             C2 -> y+16
;             C1 -> y+12
;            t_C -> y+8
;        rh_true -> y+4
;             rh -> y+0
;  p_temperature -> R12,R13
;     p_humidity -> R10,R11
	.even
_HumidityCalc::
	rcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,40
	.dbline -1
	.dbline 653
; }
; 
; /******************************************************************************
; 
; Name:			    void HumidityCalc(float *p_humidity ,float *p_temperature)
; 
; Description:	calculates temperature [C] and humidity [%RH]
; 
; Input:			  humi [Ticks] (12 bit)
;               temp [Ticks] (14 bit)
; 
; Output:			  humi [%RH]
;               temp [C]
; 
; Misc:
; 
; ******************************************************************************/
; void HumidityCalc(float *p_humidity ,float *p_temperature)
; {
	.dbline 654
;   float C1=-4.0;                      // for 12 Bit
	ldi R16,<L67
	ldi R17,>L67
	rcall lpm32
	std y+12,R16
	std y+13,R17
	std y+14,R18
	std y+15,R19
	.dbline 655
;   float C2=+0.0405;                   // for 12 Bit
	ldi R16,<L68
	ldi R17,>L68
	rcall lpm32
	std y+16,R16
	std y+17,R17
	std y+18,R18
	std y+19,R19
	.dbline 656
;   float C3=-0.0000028;                // for 12 Bit
	ldi R16,<L69
	ldi R17,>L69
	rcall lpm32
	std y+20,R16
	std y+21,R17
	std y+22,R18
	std y+23,R19
	.dbline 657
;   float T1=+0.01;                     // for 14 Bit @ 3V
	ldi R16,<L70
	ldi R17,>L70
	rcall lpm32
	std y+24,R16
	std y+25,R17
	std y+26,R18
	std y+27,R19
	.dbline 658
;   float T2=+0.00008;                  // for 14 Bit @ 3V
	ldi R16,<L71
	ldi R17,>L71
	rcall lpm32
	std y+28,R16
	std y+29,R17
	std y+30,R18
	std y+31,R19
	.dbline 660
; 
;   float rh=*p_humidity;               // rh:      Humidity [Ticks] 12 Bit
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 661
;   float t=*p_temperature;             // t:       Temperature [Ticks] 14 Bit
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+32,R2
	std y+33,R3
	std y+34,R4
	std y+35,R5
	.dbline 666
;   float rh_lin;                       // rh_lin:  Humidity linear
;   float rh_true;                      // rh_true: Temperature compensated humidity
;   float t_C;                          // t_C   :  Temperature [C]
; 
;   t_C=t*0.01 - 39.6;                  //calc. temperature from ticks to [C]
	ldi R16,<L72
	ldi R17,>L72
	rcall lpm32
	movw R24,R28
	adiw R24,32
	st -y,R25
	st -y,R24
	rcall fpmule1
	movw R2,R16
	movw R4,R18
	ldi R16,<L73
	ldi R17,>L73
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpsub2
	std y+8,R16
	std y+9,R17
	std y+10,R18
	std y+11,R19
	.dbline 667
;   rh_lin=C3*rh*rh + C2*rh + C1;       //calc. humidity from ticks to [%RH]
	ldd R16,y+20
	ldd R17,y+21
	ldd R18,y+22
	ldd R19,y+23
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1
	movw R2,R16
	movw R4,R18
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1x
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	movw R24,R28
	adiw R24,12
	st -y,R25
	st -y,R24
	rcall fpadd1
	std y+36,R16
	std y+37,R17
	std y+38,R18
	std y+39,R19
	.dbline 668
;   rh_true=(t_C-25)*(T1+T2*rh)+rh_lin; //calc. temp compensated humidity [%RH]
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldi R16,<L74
	ldi R17,>L74
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpsub2
	movw R2,R16
	movw R4,R18
	ldd R6,y+24
	ldd R7,y+25
	ldd R8,y+26
	ldd R9,y+27
	ldd R16,y+28
	ldd R17,y+29
	ldd R18,y+30
	ldd R19,y+31
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1x
	movw R16,R6
	movw R18,R8
	rcall fpadd2x
	movw R16,R2
	movw R18,R4
	rcall fpmule2
	movw R24,R28
	adiw R24,36
	st -y,R25
	st -y,R24
	rcall fpadd1
	std y+4,R16
	std y+5,R17
	std y+6,R18
	std y+7,R19
	.dbline 669
;   if(rh_true>100)rh_true=100;         //cut if the value is outside of
	movw R24,R28
	adiw R24,4
	ldi R16,<L77
	ldi R17,>L77
	rcall lpm32
	st -y,R25
	st -y,R24
	rcall fpcmp1
	brge L75
X17:
	.dbline 669
	ldi R16,<L77
	ldi R17,>L77
	rcall lpm32
	std y+4,R16
	std y+5,R17
	std y+6,R18
	std y+7,R19
L75:
	.dbline 670
;   if(rh_true<0.1)rh_true=0.1;         //the physical possible range
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldi R16,<L80
	ldi R17,>L80
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpcmp2
	brge L78
X18:
	.dbline 670
	ldi R16,<L81
	ldi R17,>L81
	rcall lpm32
	std y+4,R16
	std y+5,R17
	std y+6,R18
	std y+7,R19
L78:
	.dbline 672
; 
;   *p_temperature=t_C;                 //return temperature [C]
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	movw R30,R12
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 673
;   *p_humidity=rh_true;                //return humidity[%RH]
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline -2
L66:
	.dbline 0 ; func end
	adiw R28,40
	rjmp pop_xgset003C
	.dbsym l rh_lin 36 D
	.dbsym l t 32 D
	.dbsym l T2 28 D
	.dbsym l T1 24 D
	.dbsym l C3 20 D
	.dbsym l C2 16 D
	.dbsym l C1 12 D
	.dbsym l t_C 8 D
	.dbsym l rh_true 4 D
	.dbsym l rh 0 D
	.dbsym r p_temperature 12 pD
	.dbsym r p_humidity 10 pD
	.dbend
	.dbfunc e HumidityGet _HumidityGet fV
;       temp_val -> R14,R15
;       humi_val -> R20,R21
;  p_temperature -> R12,R13
;     p_humidity -> R10,R11
	.even
_HumidityGet::
	rcall push_xgset30FC
	movw R12,R18
	movw R10,R16
	.dbline -1
	.dbline 692
; }
; 
; /******************************************************************************
; 
; Name:			    void HumidityGet(float *p_humidity ,float *p_temperature)
; 
; Description:	measure humidity [ticks](12 bit) and temperature [ticks](14 bit)
; 
; Input:			  humi [%RH]
;               temp [C]
; 
; Output:			  humi [%RH]
;               temp [C]
; 
; Misc:
; 
; ******************************************************************************/
; void HumidityGet(float *p_humidity ,float *p_temperature)
; {
	.dbline 695
;   uint humi_val,temp_val;
; 
;   humi_val = HumidityMeasure(HUMIDITY_MEASURE_HUMI);  //measure humidity
	ldi R16,5
	rcall _HumidityMeasure
	movw R20,R16
	.dbline 696
;   temp_val = HumidityMeasure(HUMIDITY_MEASURE_TEMP);  //measure temperature
	ldi R16,3
	rcall _HumidityMeasure
	movw R14,R16
	.dbline 698
; 
;   if(HumiError == TRUE) HumidityConnectionReset();    //in case of an error: Reset
	lds R24,_HumiError
	cpi R24,1
	brne L83
X19:
	.dbline 698
	rcall _HumidityConnectionReset
	rjmp L84
L83:
	.dbline 700
;   else
;   {
	.dbline 701
;     *p_humidity=(float)humi_val;                      //converts integer to float
	movw R16,R20
	rcall uint2fp
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
	.dbline 702
;     *p_temperature=(float)temp_val;                   //converts integer to float
	movw R16,R14
	rcall uint2fp
	movw R30,R12
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
	.dbline 703
;     HumidityCalc(p_humidity,p_temperature);           //calculate humidity, temperature
	movw R18,R30
	movw R16,R10
	rcall _HumidityCalc
	.dbline 704
;   }
L84:
	.dbline -2
L82:
	.dbline 0 ; func end
	rjmp pop_xgset30FC
	.dbsym r temp_val 14 i
	.dbsym r humi_val 20 i
	.dbsym r p_temperature 12 pD
	.dbsym r p_humidity 10 pD
	.dbend
	.dbfunc e HumidityUpdate _HumidityUpdate fV
	.even
_HumidityUpdate::
	.dbline -1
	.dbline 720
; }
; 
; /******************************************************************************
; 
; Name:			void HumidityUpdate(void)
; 
; Description:
; 
; Input:
; 
; Output:
; Misc:
; 
; ******************************************************************************/
; void HumidityUpdate(void)
; {
	.dbline 721
;   if (HumiError == TRUE) HumidityInit();
	lds R24,_HumiError
	cpi R24,1
	brne L86
X20:
	.dbline 721
	rcall _HumidityInit
L86:
	.dbline 722
;   HumidityGet(&Humidity,&Temperature);
	ldi R18,<_Temperature
	ldi R19,>_Temperature
	ldi R16,<_Humidity
	ldi R17,>_Humidity
	rcall _HumidityGet
	.dbline 723
;   Hum = Humidity * 10;
	ldi R16,<L88
	ldi R17,>L88
	rcall lpm32
	ldi R24,<_Humidity
	ldi R25,>_Humidity
	st -y,R25
	st -y,R24
	rcall fpmule1
	rcall fpint
	sts _Hum+1,R17
	sts _Hum,R16
	.dbline 724
;   Temp = Temperature * 10;
	ldi R16,<L88
	ldi R17,>L88
	rcall lpm32
	ldi R24,<_Temperature
	ldi R25,>_Temperature
	st -y,R25
	st -y,R24
	rcall fpmule1
	rcall fpint
	sts _Temp+1,R17
	sts _Temp,R16
	.dbline -2
L85:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BarometerInit _BarometerInit fV
;              w -> y+6
;              i -> R20
	.even
_BarometerInit::
	st -y,R20
	sbiw R28,14
	.dbline -1
	.dbline 745
; }
; 
; //*****************************************************************************
; //          B A R O M E T E R   F U N C T I O N
; //*****************************************************************************
; /******************************************************************************
; 
; Name:			    void BarometerInit(void)
; 
; Description:	Initialise port and constant used by
;               the barometer hardware
; 
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerInit(void)
; {
	.dbline 750
;   uint w[4];
;   ushort i;
; 
;   // Timer 1
;   TCCR1A = 0x40;
	ldi R24,64
	out 0x2f,R24
	.dbline 751
;   TCCR1B = 0x09;		    // Timer 1 prescaler at /1
	ldi R24,9
	out 0x2e,R24
	.dbline 752
;   OCR1A  = 0xfa;		    // for 32khz at 16Mhz
	ldi R24,250
	ldi R25,0
	out 0x2b,R25
	out 0x2a,R24
	.dbline 754
; 
;   BAROMETER_DDR |= BAROMETER_DIN + BAROMETER_SCLK;
	in R24,0x11
	ori R24,160
	out 0x11,R24
	.dbline 755
;   BAROMETER_DDR &= ~BAROMETER_DOUT;
	cbi 0x11,6
	.dbline 757
;   
;   BAROMETER32K_DDR |= BAROMETER32K_CLK;
	sbi 0x17,1
	.dbline 759
; 
;   BaroError = FALSE;
	clr R2
	sts _BaroError,R2
	.dbline 761
; 
;   BarometerReset();
	rcall _BarometerReset
	.dbline 763
; 
;   for (i=0; i<4; i++)
	clr R20
	rjmp L93
L90:
	.dbline 764
;   {
	.dbline 765
;     w[i] = BarometerGetW(i);
	mov R16,R20
	rcall _BarometerGetW
	movw R24,R28
	adiw R24,6
	mov R30,R20
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	std z+1,R17
	std z+0,R16
	.dbline 766
;   }
L91:
	.dbline 763
	inc R20
L93:
	.dbline 763
	cpi R20,4
	brlo L90
X21:
	.dbline 768
; 
;   for (i=0; i<6; i++)
	clr R20
	rjmp L97
L94:
	.dbline 769
;   {
	.dbline 770
;     fc[i] = BarometerConvertWtoC5534(i, w[0], w[1], w[2], w[3]);
	ldd R2,y+12
	ldd R3,y+13
	std y+5,R3
	std y+4,R2
	ldd R2,y+10
	ldd R3,y+11
	std y+3,R3
	std y+2,R2
	ldd R2,y+8
	ldd R3,y+9
	std y+1,R3
	std y+0,R2
	ldd R18,y+6
	ldd R19,y+7
	mov R16,R20
	rcall _BarometerConvertWtoC5534
	ldi R24,<_fc
	ldi R25,>_fc
	mov R30,R20
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	std z+1,R17
	std z+0,R16
	.dbline 771
;   }
L95:
	.dbline 768
	inc R20
L97:
	.dbline 768
	cpi R20,6
	brlo L94
X22:
	.dbline -2
L89:
	.dbline 0 ; func end
	adiw R28,14
	ld R20,y+
	ret
	.dbsym l w 6 A[8:4]i
	.dbsym r i 20 c
	.dbend
	.dbfunc e BarometerUpdate _BarometerUpdate fV
;             d2 -> R12,R13
;             d1 -> R10,R11
	.even
_BarometerUpdate::
	rcall push_xgset003C
	sbiw R28,4
	.dbline -1
	.dbline 789
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerUpdate(void)
; 
; Description:  Update the variable (float)Pres with the current 
;               humidity
; 
; 
; Input:			  none
; 
; Output:			  Global variable Pres
; 
; Misc:
; ******************************************************************************/
; void BarometerUpdate(void)
; {
	.dbline 792
;   uint d1,d2;
; 
;   if (BaroError == TRUE) BarometerInit();
	lds R24,_BaroError
	cpi R24,1
	brne L102
X23:
	.dbline 792
	rcall _BarometerInit
L102:
	.dbline 793
;   d1 = BarometerGetD1();
	rcall _BarometerGetD1
	movw R10,R16
	.dbline 794
;   d2 = BarometerGetD2();
	rcall _BarometerGetD2
	movw R12,R16
	.dbline 795
;   BarometerCalcPT5534(&Pressure,&BaroTemp,d1, d2);
	std y+3,R13
	std y+2,R12
	std y+1,R11
	std y+0,R10
	ldi R18,<_BaroTemp
	ldi R19,>_BaroTemp
	ldi R16,<_Pressure
	ldi R17,>_Pressure
	rcall _BarometerCalcPT5534
	.dbline 796
;   Pressure = (Pressure - 1013.25) * 10;
	ldi R16,<L104
	ldi R17,>L104
	rcall lpm32
	movw R2,R16
	movw R4,R18
	lds R8,_Pressure+2
	lds R9,_Pressure+2+1
	lds R6,_Pressure
	lds R7,_Pressure+1
	ldi R16,<L105
	ldi R17,>L105
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpsub2x
	movw R16,R2
	movw R18,R4
	rcall fpmule2
	sts _Pressure+1,R17
	sts _Pressure,R16
	sts _Pressure+2+1,R19
	sts _Pressure+2,R18
	.dbline 797
;   Pres = (int)Pressure;
	rcall fpint
	sts _Pres+1,R17
	sts _Pres,R16
	.dbline -2
L101:
	.dbline 0 ; func end
	adiw R28,4
	rjmp pop_xgset003C
	.dbsym r d2 12 i
	.dbsym r d1 10 i
	.dbend
	.dbfunc e BarometerCalcPT5534 _BarometerCalcPT5534 fV
;           sens -> y+20
;            off -> y+16
;              x -> y+12
;            fd2 -> y+8
;            fd1 -> y+4
;             dt -> y+0
;         d2_arg -> y+30
;         d1_arg -> y+28
;    temperature -> R10,R11
;       pressure -> R12,R13
	.even
_BarometerCalcPT5534::
	rcall push_xgset003C
	movw R10,R18
	movw R12,R16
	sbiw R28,24
	.dbline -1
	.dbline 825
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerBarometerCalcPT5534(float *pressure,
;                                                 float *temperature,
;                                                 uint d1_arg,
;                                                 uint d2_arg)
; 
; 
; Description:	Calculate the pressure & temparature with
;               the given d1_arg and d2_ard
; 
; 
; Input:			  float *pressure -> Pointer to pressure value to store
;               float *temperature -> Pointer to temp value to store
;               uint d1_arg -> value of d1
;               uint d2_arg -> value of d2
; 
; Output:			none
; 
; Misc:
; ******************************************************************************/
; void BarometerCalcPT5534( float *pressure,
;                           float *temperature,
;                           uint d1_arg,
;                           uint d2_arg)
; {
	.dbline 828
;   float fd1, fd2, x,dt, off, sens;
; 
;   fd1 = (float) d1_arg;
	ldd R16,y+28
	ldd R17,y+29
	rcall uint2fp
	std y+4,R16
	std y+5,R17
	std y+6,R18
	std y+7,R19
	.dbline 829
;   fd2 = (float) d2_arg;
	ldd R16,y+30
	ldd R17,y+31
	rcall uint2fp
	std y+8,R16
	std y+9,R17
	std y+10,R18
	std y+11,R19
	.dbline 831
; 
;   dt   =   fd2 - ((8.0 * fc[4]) + 20224.0);
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldi R16,<L108
	ldi R17,>L108
	rcall lpm32
	movw R6,R16
	movw R8,R18
	lds R16,_fc+8
	lds R17,_fc+8+1
	rcall uint2fp
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpmule2
	movw R6,R16
	movw R8,R18
	ldi R16,<L109
	ldi R17,>L109
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpadd2x
	movw R16,R2
	movw R18,R4
	rcall fpsub2
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
	.dbline 832
;   off  =   fc[1] * 4.0 + (((fc[3]-512.0)*dt)/4096.0);
	ldi R16,<L112
	ldi R17,>L112
	rcall lpm32
	movw R2,R16
	movw R4,R18
	lds R16,_fc+2
	lds R17,_fc+2+1
	rcall uint2fp
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpmule2
	movw R2,R16
	movw R4,R18
	lds R16,_fc+6
	lds R17,_fc+6+1
	rcall uint2fp
	movw R6,R16
	movw R8,R18
	ldi R16,<L113
	ldi R17,>L113
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpsub2
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1
	movw R6,R16
	movw R8,R18
	ldi R16,<L114
	ldi R17,>L114
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpdiv2x
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	std y+16,R16
	std y+17,R17
	std y+18,R18
	std y+19,R19
	.dbline 833
;   sens =   24576.0 +  fc[0] + ((fc[2]*dt)/1024.0);
	lds R16,_fc
	lds R17,_fc+1
	rcall uint2fp
	movw R2,R16
	movw R4,R18
	ldi R16,<L116
	ldi R17,>L116
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	movw R2,R16
	movw R4,R18
	lds R16,_fc+4
	lds R17,_fc+4+1
	rcall uint2fp
	movw R24,R28
	st -y,R25
	st -y,R24
	rcall fpmule1
	movw R6,R16
	movw R8,R18
	ldi R16,<L117
	ldi R17,>L117
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpdiv2x
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	std y+20,R16
	std y+21,R17
	std y+22,R18
	std y+23,R19
	.dbline 834
;   x    =   (( sens * (fd1- 7168.0)) / 16384.0) - off;
	ldd R2,y+20
	ldd R3,y+21
	ldd R4,y+22
	ldd R5,y+23
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	ldi R16,<L118
	ldi R17,>L118
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpsub2x
	movw R16,R2
	movw R18,R4
	rcall fpmule2
	movw R2,R16
	movw R4,R18
	ldi R16,<L119
	ldi R17,>L119
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpdiv2
	movw R24,R28
	adiw R24,16
	st -y,R25
	st -y,R24
	rcall fpsub1
	std y+12,R16
	std y+13,R17
	std y+14,R18
	std y+15,R19
	.dbline 835
;   *pressure = 250.0 + x / 32;
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	ldi R16,<L120
	ldi R17,>L120
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpdiv2
	movw R2,R16
	movw R4,R18
	ldi R16,<L121
	ldi R17,>L121
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	movw R30,R12
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
	.dbline 836
;   *temperature =  (200 +((dt*(fc[5]+50.0))/1024.0))/10;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	lds R16,_fc+10
	lds R17,_fc+10+1
	rcall uint2fp
	movw R6,R16
	movw R8,R18
	ldi R16,<L123
	ldi R17,>L123
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R6
	movw R18,R8
	rcall fpadd2x
	movw R16,R2
	movw R18,R4
	rcall fpmule2
	movw R2,R16
	movw R4,R18
	ldi R16,<L117
	ldi R17,>L117
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpdiv2
	movw R2,R16
	movw R4,R18
	ldi R16,<L124
	ldi R17,>L124
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpadd2
	movw R2,R16
	movw R4,R18
	ldi R16,<L104
	ldi R17,>L104
	rcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	rcall fpdiv2
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
	.dbline -2
L106:
	.dbline 0 ; func end
	adiw R28,24
	rjmp pop_xgset003C
	.dbsym l sens 20 D
	.dbsym l off 16 D
	.dbsym l x 12 D
	.dbsym l fd2 8 D
	.dbsym l fd1 4 D
	.dbsym l dt 0 D
	.dbsym l d2_arg 30 i
	.dbsym l d1_arg 28 i
	.dbsym r temperature 10 pD
	.dbsym r pressure 12 pD
	.dbend
	.dbfunc e BarometerConvertWtoC5534 _BarometerConvertWtoC5534 fi
;              y -> R10,R11
;              x -> R12,R13
;              c -> R20,R21
;             W4 -> R22,R23
;             W3 -> R14,R15
;             W2 -> y+12
;             W1 -> y+10
;             ix -> R10
	.even
_BarometerConvertWtoC5534::
	st -y,r19
	st -y,r18
	rcall push_xgsetF0FC
	mov R10,R16
	ldd R14,y+14
	ldd R15,y+15
	ldd R22,y+16
	ldd R23,y+17
	.dbline -1
	.dbline 866
; }
; 
; /******************************************************************************
; 
; Name:			    uint BarometerConvertWtoC5534(ushort ix,
;                                                     uint W1,
;                                                     uint W2,
;                                                     uint W3,
;                                                     uint W4)
; 
; Description:	Convert W value to Constant used by BarometerCalcPT5534
;               to give a result
; 
; 
; Input:			  ushort ix -> Constant to find (0 to 5)
;               uint W1  -> Value #1 from 16bit rom
;               uint W2  -> Value #2 from 16bit rom
;               uint W3  -> Value #3 from 16bit rom
;               uint W4  -> Value #4 from 16bit rom
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; uint BarometerConvertWtoC5534(ushort ix,
;                                       uint W1,
;                                       uint W2,
;                                       uint W3,
;                                       uint W4)
; {
	.dbline 870
;   uint c;
;   uint x, y;
; 
;   c = 0;
	clr R20
	clr R21
	.dbline 871
;   switch (ix)
	clr R11
	tst R10
	brne X24
	tst R11
	breq L129
X24:
	movw R24,R10
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L130
X25:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L131
X26:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	breq L132
X27:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	brne X30
	rjmp L133
X30:
X28:
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne X31
	rjmp L134
X31:
X29:
	rjmp L126
L129:
	.dbline 874
;   {
;     case 0:
;     c =  (W1 >> 1) & 0x7FFF;
	ldd R20,y+10
	ldd R21,y+11
	lsr R21
	ror R20
	andi R21,127
	.dbline 875
;     break;
	rjmp L127
L130:
	.dbline 877
;     case 1:
;     x = (W3 << 6) & 0x0FC0;
	ldi R18,6
	ldi R19,0
	movw R16,R14
	rcall lsl16
	movw R24,R16
	andi R24,192
	andi R25,15
	movw R12,R24
	.dbline 878
;     y =  W4       & 0x003F;
	movw R24,R22
	andi R24,63
	andi R25,0
	movw R10,R24
	.dbline 879
;     c = x | y;
	movw R20,R12
	or R20,R24
	or R21,R25
	.dbline 880
;     break;
	rjmp L127
L131:
	.dbline 882
;     case 2:
;     c = (W4 >> 6) & 0x03FF;
	ldi R18,6
	ldi R19,0
	movw R16,R22
	rcall lsr16
	movw R20,R16
	andi R21,3
	.dbline 883
;     break;
	rjmp L127
L132:
	.dbline 885
;     case 3:
;     c = (W3 >> 6) & 0x03FF;
	ldi R18,6
	ldi R19,0
	movw R16,R14
	rcall lsr16
	movw R20,R16
	andi R21,3
	.dbline 886
;     break;
	rjmp L127
L133:
	.dbline 888
;     case 4:
;     x = (W1 << 10)& 0x0400;
	ldi R18,10
	ldi R19,0
	ldd R16,y+10
	ldd R17,y+11
	rcall lsl16
	movw R24,R16
	andi R24,0
	andi R25,4
	movw R12,R24
	.dbline 889
;     y = (W2 >> 6 )& 0x03FF;
	ldi R18,6
	ldi R19,0
	ldd R16,y+12
	ldd R17,y+13
	rcall lsr16
	movw R24,R16
	andi R25,3
	movw R10,R24
	.dbline 890
;     c = x | y;
	movw R20,R12
	or R20,R24
	or R21,R25
	.dbline 891
;     break;
	rjmp L127
L134:
	.dbline 893
;     case 5:
;     c =  W2       & 0x003F;
	ldd R20,y+12
	ldd R21,y+13
	andi R20,63
	andi R21,0
	.dbline 894
;     break;
L126:
L127:
	.dbline 896
;   }
;   return(c);
	movw R16,R20
	.dbline -2
L125:
	.dbline 0 ; func end
	rcall pop_xgsetF0FC
	adiw R28,2
	ret
	.dbsym r y 10 i
	.dbsym r x 12 i
	.dbsym r c 20 i
	.dbsym r W4 22 i
	.dbsym r W3 14 i
	.dbsym l W2 12 i
	.dbsym l W1 10 i
	.dbsym r ix 10 c
	.dbend
	.dbfunc e BarometerGetD1 _BarometerGetD1 fi
;             d1 -> R10,R11
	.even
_BarometerGetD1::
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 914
; }
; 
; /******************************************************************************
; 
; Name:			    uint BarometerGetD1(void)
; 
; Description:	Start a pressure "D1" convertion and return
;               the result
; 
; 
; Input:			  none
; 
; Output:			  int -> Pressure value (RAW data)
; 
; Misc:
; ******************************************************************************/
; uint BarometerGetD1(void)
; {
	.dbline 917
;   uint d1;
; 
;   BarometerSendLsbFirst(0x2F, 8);
	ldi R18,8
	ldi R16,47
	rcall _BarometerSendLsbFirst
	.dbline 918
;   BarometerSendLsbFirst(0x00, 2);
	ldi R18,2
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 920
; 
;   if (BarometerGetDOUT()==FALSE) BaroError = 1;   // line should be at 1 now
	rcall _BarometerGetDOUT
	tst R16
	brne L136
X32:
	.dbline 920
	ldi R24,1
	sts _BaroError,R24
L136:
	.dbline 921
;   BarometerSendLsbFirst(0x00, 2);
	ldi R18,2
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 923
; 
;   if (!BaroError) BaroError = BarometerWaitOnDoutFall();
	lds R2,_BaroError
	tst R2
	brne L138
X33:
	.dbline 923
	rcall _BarometerWaitOnDoutFall
	sts _BaroError,R16
L138:
	.dbline 924
;   if (!BaroError) d1 = BarometerGet16();
	lds R2,_BaroError
	tst R2
	brne L140
X34:
	.dbline 924
	rcall _BarometerGet16
	movw R10,R16
	rjmp L141
L140:
	.dbline 925
;   else d1 = 0;
	clr R10
	clr R11
L141:
	.dbline 926
;   return(d1);
	movw R16,R10
	.dbline -2
L135:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r d1 10 i
	.dbend
	.dbfunc e BarometerGetD2 _BarometerGetD2 fi
;             d2 -> R10,R11
	.even
_BarometerGetD2::
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 944
; }
; 
; /******************************************************************************
; 
; Name:			    uint BarometerGetD2(void)
; 
; Description:	Start a temperature "D2" convertion and return
; the result
; 
; 
; Input:			  none
; 
; Output:			  int -> Temp value (RAW data)
; 
; Misc:
; ******************************************************************************/
; uint BarometerGetD2(void)
; {
	.dbline 947
;   uint d2;
; 
;   BarometerSendLsbFirst(0x4F, 8);
	ldi R18,8
	ldi R16,79
	rcall _BarometerSendLsbFirst
	.dbline 948
;   BarometerSendLsbFirst(0x00, 3);                 // Note the difference 
	ldi R18,3
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 951
;                                                   // with BarometerGetD1
; 
;   if (BarometerGetDOUT()==FALSE) BaroError = 1;   // line should be at 1 now
	rcall _BarometerGetDOUT
	tst R16
	brne L143
X35:
	.dbline 951
	ldi R24,1
	sts _BaroError,R24
L143:
	.dbline 952
;   BarometerSendLsbFirst(0x00, 1);
	ldi R18,1
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 954
; 
;   if (!BaroError) BaroError = BarometerWaitOnDoutFall();
	lds R2,_BaroError
	tst R2
	brne L145
X36:
	.dbline 954
	rcall _BarometerWaitOnDoutFall
	sts _BaroError,R16
L145:
	.dbline 955
;   if (!BaroError) d2 = BarometerGet16();
	lds R2,_BaroError
	tst R2
	brne L147
X37:
	.dbline 955
	rcall _BarometerGet16
	movw R10,R16
	rjmp L148
L147:
	.dbline 956
;   else d2 = 0;
	clr R10
	clr R11
L148:
	.dbline 957
;   return(d2);
	movw R16,R10
	.dbline -2
L142:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r d2 10 i
	.dbend
	.dbfunc e BarometerGetW _BarometerGetW fi
;           data -> R10,R11
;          index -> R12
	.even
_BarometerGetW::
	rcall push_xgset303C
	mov R12,R16
	.dbline -1
	.dbline 973
; }
; 
; /******************************************************************************
; 
; Name:			    uint BarometerGetW(ushort index)
; 
; Description:	Get the Rom constant
; 
; Input:			  uchar -> rom x to get (0 to 3)
; 
; Output:			  int -> Rom value
; 
; Misc:
; ******************************************************************************/
; uint BarometerGetW(ushort index)
; {
	.dbline 976
;   uint data;
; 
;   data = 0;
	clr R10
	clr R11
	.dbline 977
;   switch (index)
	mov R20,R12
	clr R21
	cpi R20,0
	cpc R20,R21
	breq L153
X38:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	breq L154
X39:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	breq L155
X40:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	breq L156
X41:
	rjmp L150
L153:
	.dbline 980
;   {
;     case 0:
;     BarometerSendLsbFirst((char) 0x57, (char) 8);
	ldi R18,8
	ldi R16,87
	rcall _BarometerSendLsbFirst
	.dbline 981
;     BarometerSendLsbFirst((char) 0x01, (char) 5);
	ldi R18,5
	ldi R16,1
	rcall _BarometerSendLsbFirst
	.dbline 982
;     data = BarometerGet16();
	rcall _BarometerGet16
	movw R10,R16
	.dbline 983
;     break;
	rjmp L151
L154:
	.dbline 986
; 
;     case 1:
;     BarometerSendLsbFirst((char) 0xD7, (char) 8);
	ldi R18,8
	ldi R16,215
	rcall _BarometerSendLsbFirst
	.dbline 987
;     BarometerSendLsbFirst((char) 0x00, (char) 5);
	ldi R18,5
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 988
;     data = BarometerGet16();
	rcall _BarometerGet16
	movw R10,R16
	.dbline 989
;     break;
	rjmp L151
L155:
	.dbline 992
; 
;     case 2:
;     BarometerSendLsbFirst((char) 0x37, (char) 8);
	ldi R18,8
	ldi R16,55
	rcall _BarometerSendLsbFirst
	.dbline 993
;     BarometerSendLsbFirst((char) 0x01, (char) 5);
	ldi R18,5
	ldi R16,1
	rcall _BarometerSendLsbFirst
	.dbline 994
;     data = BarometerGet16();
	rcall _BarometerGet16
	movw R12,R16
	movw R10,R12
	.dbline 995
;     break;
	rjmp L151
L156:
	.dbline 998
; 
;     case 3:
;     BarometerSendLsbFirst((char) 0xB7, (char) 8);
	ldi R18,8
	ldi R16,183
	rcall _BarometerSendLsbFirst
	.dbline 999
;     BarometerSendLsbFirst((char) 0x00, (char) 5);
	ldi R18,5
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 1000
;     data = BarometerGet16();
	rcall _BarometerGet16
	movw R12,R16
	movw R10,R12
	.dbline 1001
;     break;
L150:
L151:
	.dbline 1003
;   }
;   BarometerSendLsbFirst(0x00, 1);  // to be compliant with the data sheet
	ldi R18,1
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline 1004
;   return(data);
	movw R16,R10
	.dbline -2
L149:
	.dbline 0 ; func end
	rjmp pop_xgset303C
	.dbsym r data 10 i
	.dbsym r index 12 c
	.dbend
	.dbfunc e BarometerReset _BarometerReset fV
	.even
_BarometerReset::
	.dbline -1
	.dbline 1020
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerReset(void)
; 
; Description:	Send a Reset commend to the barometer
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerReset(void)
; {
	.dbline 1021
;   BarometerSendLsbFirst(0x55, 8);
	ldi R18,8
	ldi R16,85
	rcall _BarometerSendLsbFirst
	.dbline 1022
;   BarometerSendLsbFirst(0x55, 8);
	ldi R18,8
	ldi R16,85
	rcall _BarometerSendLsbFirst
	.dbline 1023
;   BarometerSendLsbFirst(0x00, 5);
	ldi R18,5
	clr R16
	rcall _BarometerSendLsbFirst
	.dbline -2
L157:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BarometerGet16 _BarometerGet16 fi
;              i -> R22
;              v -> R20,R21
	.even
_BarometerGet16::
	rcall push_xgsetF000
	.dbline -1
	.dbline 1039
; }
; 
; /******************************************************************************
; 
; Name:			    uint BarometerGet16(void)
; 
; Description:	Get a 16 bit value from the barometer
; 
; Input:			  none
; 
; Output:			  uint -> readed value
; 
; Misc:
; ******************************************************************************/
; uint BarometerGet16(void)
; {
	.dbline 1043
;   char i;
;   uint v;
; 
;   v = 0;
	clr R20
	clr R21
	.dbline 1044
;   BarometerSetSCLK(FALSE);
	clr R16
	rcall _BarometerSetSCLK
	.dbline 1045
;   BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1047
; 
;   for (i=0; i<16; i++)
	clr R22
	rjmp L162
L159:
	.dbline 1048
;   {
	.dbline 1049
;     BarometerSetSCLK(TRUE);
	ldi R16,1
	rcall _BarometerSetSCLK
	.dbline 1050
;     BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1051
;     BarometerSetSCLK(FALSE);
	clr R16
	rcall _BarometerSetSCLK
	.dbline 1052
;     v = v << 1;
	lsl R20
	rol R21
	.dbline 1053
;     if (BarometerGetDOUT()) v = v | 1;
	rcall _BarometerGetDOUT
	tst R16
	breq L163
X42:
	.dbline 1053
	ori R20,1
L163:
	.dbline 1054
;     BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1055
;   }
L160:
	.dbline 1047
	inc R22
L162:
	.dbline 1047
	cpi R22,16
	brlo L159
X43:
	.dbline 1056
;   return(v);
	movw R16,R20
	.dbline -2
L158:
	.dbline 0 ; func end
	rjmp pop_xgsetF000
	.dbsym r i 22 c
	.dbsym r v 20 i
	.dbend
	.dbfunc e BarometerSendLsbFirst _BarometerSendLsbFirst fV
;              c -> R20
;              i -> R10
;      nbr_clock -> R14
;        pattern -> R12
	.even
_BarometerSendLsbFirst::
	rcall push_xgset30FC
	mov R14,R18
	mov R12,R16
	.dbline -1
	.dbline 1073
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerSendLsbFirst(char pattern, char nbr_clock)
; 
; Description:	Send a value to the barometer
; 
; Input:			  char pattern   -> byte value to send
;               char nbr_clock -> qte of bit to send of the given byte
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerSendLsbFirst(char pattern, char nbr_clock)
; {
	.dbline 1077
;   char i;
;   char c;
; 
;   BarometerSetSCLK(FALSE);
	clr R16
	rcall _BarometerSetSCLK
	.dbline 1078
;   BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1079
;   for (i=0; i<nbr_clock; i++)
	clr R10
	rjmp L169
L166:
	.dbline 1080
;   {
	.dbline 1081
;     c = (char) (pattern & 1);
	mov R20,R12
	clr R21
	andi R20,1
	andi R21,0
	.dbline 1082
;     if (c==1) BarometerSetDIN(TRUE);
	cpi R20,1
	brne L170
X44:
	.dbline 1082
	ldi R16,1
	rcall _BarometerSetDIN
	rjmp L171
L170:
	.dbline 1083
;     else BarometerSetDIN(FALSE);
	clr R16
	rcall _BarometerSetDIN
L171:
	.dbline 1084
;     BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1085
;     BarometerSetSCLK(TRUE);
	ldi R16,1
	rcall _BarometerSetSCLK
	.dbline 1086
;     BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1087
;     BarometerSetSCLK(FALSE);
	clr R16
	rcall _BarometerSetSCLK
	.dbline 1088
;     pattern = (char) (pattern >> 1);
	lsr R12
	.dbline 1089
;   }
L167:
	.dbline 1079
	inc R10
L169:
	.dbline 1079
	cp R10,R14
	brlo L166
X45:
	.dbline -2
L165:
	.dbline 0 ; func end
	rjmp pop_xgset30FC
	.dbsym r c 20 c
	.dbsym r i 10 c
	.dbsym r nbr_clock 14 c
	.dbsym r pattern 12 c
	.dbend
	.dbfunc e BarometerWaitOnDoutFall _BarometerWaitOnDoutFall fc
;          error -> R20
;            cnt -> y+0
;        working -> R22
	.even
_BarometerWaitOnDoutFall::
	st -y,R20
	st -y,R22
	sbiw R28,4
	.dbline -1
	.dbline 1106
; }
; 
; /******************************************************************************
; 
; Name:			    ushort BarometerWaitOnDoutFall(void)
; 
; Description:	Wait for the end of convertion
; 
; Input:			  none
; 
; Output:			  uchar error -> 0 no error
;                           -> else error
; 
; Misc:
; ******************************************************************************/
; ushort BarometerWaitOnDoutFall(void)
; {
	.dbline 1111
;   ushort working;
;   long cnt;
;   ushort error;
; 
;   working = TRUE;
	ldi R22,1
	.dbline 1112
;   error   = 0;
	clr R20
	.dbline 1114
; 
;   BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1115
;   cnt = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	rjmp L174
L173:
	.dbline 1117
;   while (working)
;   {
	.dbline 1118
;     WDR();
	wdr
	.dbline 1119
;     working = BarometerGetDOUT();
	rcall _BarometerGetDOUT
	mov R22,R16
	.dbline 1120
;     cnt++;
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 1121
;     BarometerWaitOnePulse();
	rcall _BarometerWaitOnePulse
	.dbline 1122
;     if (cnt>=20000)
	ldi R24,32
	ldi R25,78
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brlt L176
X46:
	.dbline 1123
;     {
	.dbline 1124
;       working = FALSE;
	clr R22
	.dbline 1125
;       error   = 1;
	ldi R20,1
	.dbline 1126
;     }
L176:
	.dbline 1127
;   }
L174:
	.dbline 1116
	tst R22
	brne L173
X47:
	.dbline 1128
;   return(error);
	mov R16,R20
	.dbline -2
L172:
	.dbline 0 ; func end
	adiw R28,4
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r error 20 c
	.dbsym l cnt 0 L
	.dbsym r working 22 c
	.dbend
	.dbfunc e BarometerSetSCLK _BarometerSetSCLK fV
;          state -> R16
	.even
_BarometerSetSCLK::
	.dbline -1
	.dbline 1144
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerSetSCLK(ushort state)
; 
; Description:	Set the barometer clock line
; 
; Input:			  uchar state -> 0 or 1
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerSetSCLK(ushort state)
; {
	.dbline 1145
;   CLI();
	cli
	.dbline 1146
;   if (state) BAROMETER_PORT |= BAROMETER_SCLK;
	tst R16
	breq L179
X48:
	.dbline 1146
	sbi 0x12,7
	rjmp L180
L179:
	.dbline 1147
;   else BAROMETER_PORT &= ~BAROMETER_SCLK;
	cbi 0x12,7
L180:
	.dbline 1148
;   SEI();
	sei
	.dbline -2
L178:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e BarometerGetSCLK _BarometerGetSCLK fc
	.even
_BarometerGetSCLK::
	.dbline -1
	.dbline 1164
; }
; 
; /******************************************************************************
; 
; Name:			    ushort BarometerGetSCLK(void)
; 
; Description:	Get the barometer clock line
; 
; Input:			  none
; 
; Output:			  uchar state -> 0 or 1
; 
; Misc:
; ******************************************************************************/
; ushort BarometerGetSCLK(void)
; {
	.dbline 1165
;   CLI();
	cli
	.dbline 1166
;   if ((BAROMETER_PIN & BAROMETER_SCLK)) 
	sbis 0x10,7
	rjmp L182
X49:
	.dbline 1167
;     {
	.dbline 1168
;       SEI();
	sei
	.dbline 1169
;       return 1;
	ldi R16,1
	rjmp L181
L182:
	.dbline 1172
;     }
;   else 
;     {
	.dbline 1173
;       SEI();
	sei
	.dbline 1174
;       return 0;
	clr R16
	.dbline -2
L181:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BarometerSetDIN _BarometerSetDIN fV
;          state -> R16
	.even
_BarometerSetDIN::
	.dbline -1
	.dbline 1191
;     }
; }
; 
; /******************************************************************************
; 
; Name:			    void BarometerSetDIN(ushort state)
; 
; Description:	Set the barometer data in line
; 
; Input:			  uchar state -> 0 or 1
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerSetDIN(ushort state)
; {
	.dbline 1192
;   CLI();
	cli
	.dbline 1193
;   if (state) BAROMETER_PORT |= BAROMETER_DIN;
	tst R16
	breq L185
X50:
	.dbline 1193
	sbi 0x12,5
	rjmp L186
L185:
	.dbline 1194
;   else BAROMETER_PORT &= ~BAROMETER_DIN;
	cbi 0x12,5
L186:
	.dbline 1195
;   SEI();
	sei
	.dbline -2
L184:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e BarometerGetDIN _BarometerGetDIN fc
	.even
_BarometerGetDIN::
	.dbline -1
	.dbline 1211
; }
; 
; /******************************************************************************
; 
; Name:			    ushort BarometerGetDIN(void)
; 
; Description:	Get the barometer data in line
; 
; Input:			  none
; 
; Output:			  uchar state -> 0 or 1
; 
; Misc:
; ******************************************************************************/
; ushort BarometerGetDIN(void)
; {
	.dbline 1212
;   CLI();
	cli
	.dbline 1213
;   if ((BAROMETER_PIN & BAROMETER_DIN)) 
	sbis 0x10,5
	rjmp L188
X51:
	.dbline 1214
;   {
	.dbline 1215
;     SEI();
	sei
	.dbline 1216
;     return 1;
	ldi R16,1
	rjmp L187
L188:
	.dbline 1219
;   }
;   else 
;   {
	.dbline 1220
;     SEI();
	sei
	.dbline 1221
;     return 0;
	clr R16
	.dbline -2
L187:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BarometerGetDOUT _BarometerGetDOUT fc
	.even
_BarometerGetDOUT::
	.dbline -1
	.dbline 1238
;   }
; }
; 
; /******************************************************************************
; 
; Name:			    ushort BarometerGetDOUT(void)
; 
; Description:	Get the barometer data out line
; 
; Input:			  none
; 
; Output:			  uchar state -> 0 or 1
; 
; Misc:
; ******************************************************************************/
; ushort BarometerGetDOUT(void)
; {
	.dbline 1239
;   CLI();
	cli
	.dbline 1240
;   if ((BAROMETER_PIN & BAROMETER_DOUT)) 
	sbis 0x10,6
	rjmp L191
X52:
	.dbline 1241
;   {
	.dbline 1242
;     SEI();
	sei
	.dbline 1243
;     return 1;
	ldi R16,1
	rjmp L190
L191:
	.dbline 1246
;   }
;   else 
;   {
	.dbline 1247
;     SEI();
	sei
	.dbline 1248
;     return 0;
	clr R16
	.dbline -2
L190:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BarometerWaitOnePulse _BarometerWaitOnePulse fV
;              i -> R16
	.even
_BarometerWaitOnePulse::
	.dbline -1
	.dbline 1265
;   }
; }
; 
; /******************************************************************************
; 
; Name:			    void   BarometerWaitOnePulse(void)
; 
; Description:	Clock & Data line delay for 300khz max
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:
; ******************************************************************************/
; void BarometerWaitOnePulse(void)
; {
	.dbline 1267
;   ushort i;
;   for (i=0;i<(XTAL/320000);i++) WDR();
	clr R16
	rjmp L197
L194:
	.dbline 1267
	wdr
L195:
	.dbline 1267
	inc R16
L197:
	.dbline 1267
	ldi R24,50
	ldi R25,0
	ldi R26,0
	ldi R27,0
	mov R2,R16
	clr R3
	clr R4
	clr R5
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brlt L194
X53:
	.dbline -2
L193:
	.dbline 0 ; func end
	ret
	.dbsym r i 16 c
	.dbend
	.dbfunc e NetInit _NetInit fV
	.even
_NetInit::
	.dbline -1
	.dbline 1286
; }
; 
; //*****************************************************************************
; //        N E T W O R K     F U N C T I O N
; //*****************************************************************************
; /******************************************************************************
; 
; Name:         void NetInit(void)
; 
; Description:  This function initialize for NET network
; 
; Input:        None
; 
; Output:       None
; 
; Misc:
; ******************************************************************************/
; void NetInit(void)
; {
	.dbline 1287
;   NET_UBRRH = ((XTAL / (16 * NET_SPEED)) - 1)>>8;	//set baud rate hi
	clr R2
	out 0x20,R2
	.dbline 1288
;   NET_UBRRL = (XTAL / (16 * NET_SPEED)) - 1;      //set baud rate
	ldi R24,51
	out 0x9,R24
	.dbline 1289
;   NET_UCSRA = (1<<MPCM);
	ldi R24,1
	out 0xb,R24
	.dbline 1290
;   NET_UCSRB = (1<<UCSZ2) + (1<<RXCIE)+(1<<RXEN)+(1<<TXEN)+(1<<TXCIE);
	ldi R24,220
	out 0xa,R24
	.dbline 1291
;   NET_UCSRC = (1<<URSEL)+(1<<UCSZ1) + (1<<UCSZ0);	// 8 bit
	ldi R24,134
	out 0x20,R24
	.dbline 1292
;   NET_PORT &= ~NET_TXE;               						// Switch NET in Rx mode
	cbi 0x12,2
	.dbline 1293
;   NET_PORT |= NET_RX;	                            // Pull up on RX
	sbi 0x12,0
	.dbline 1294
;   NET_DDR |= NET_TXE + NET_TX;
	in R24,0x11
	ori R24,6
	out 0x11,R24
	.dbline 1295
;   NET_ADDRESS_DDR = 0x00;              						// All port as input
	out 0x14,R2
	.dbline 1296
;   NET_ADDRESS_PORT = 0xff;             						// All port as pullup
	ldi R24,255
	out 0x15,R24
	.dbline 1297
;   NetGetAddress();
	rcall _NetGetAddress
	.dbline -2
L198:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 22
	rjmp _NetRxChar
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.area bss(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
L200:
	.blkb 1
L201:
	.blkb 1
L202:
	.blkb 1
L203:
	.blkb 2
L204:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbfunc e NetRxChar _NetRxChar fV
	.dbsym s State L204 c
	.dbsym s Ptr L203 pc
	.dbsym s CheckSum L202 c
	.dbsym s Qte L201 c
	.dbsym s InByte L200 c
	.even
_NetRxChar::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R20
	st -y,R21
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	st -y,R20
	st -y,R21
	sbiw R28,1
	.dbline -1
	.dbline 1321
; }
; 
; /******************************************************************************
; 
; Name:         void NetRxChar(void)
; 
; Description:  This function is automaticaly called each
;               time a char is received on the NET bus.
; 
; 
; Input:        none
; 
; Output:       Data in NetRxData[]
; 
; Misc:
; ******************************************************************************/
; #define RESET     0
; #define QTE       1
; #define DATA      2
; #define CHECKSUM  3
; 
; #pragma interrupt_handler NetRxChar:12
; void NetRxChar(void)
; {
	.dbline 1328
;   static ushort InByte;
;   static ushort Qte;
;   static ushort CheckSum;
;   static ushort *Ptr;
;   static ushort State;
; 
;   if (NET_UCSRA & ((1<<FE)+(1<<DOR)))
	in R24,0xb
	andi R24,24
	breq L205
X54:
	.dbline 1329
;   {
	.dbline 1330
;     InByte = NET_UDR;
	in R2,0xc
	sts L200,R2
	.dbline 1331
;     return;
	rjmp L199
L205:
	.dbline 1334
;   }
; 
;   if (NET_UCSRB & (1<<RXB8))
	sbis 0xa,1
	rjmp L207
X55:
	.dbline 1335
;   {
	.dbline 1336
;     InByte = NET_UDR;
	in R2,0xc
	sts L200,R2
	.dbline 1337
;     if (InByte == NetAddress) 
	lds R2,_NetAddress
	lds R3,L200
	cp R3,R2
	brne L209
X56:
	.dbline 1338
;     {
	.dbline 1339
;       NET_UCSRA &= ~(1<<MPCM);
	cbi 0xb,0
	.dbline 1340
;       State = QTE;
	ldi R24,1
	sts L204,R24
	.dbline 1341
;       NetBroadCast = FALSE;
	clr R2
	sts _NetBroadCast,R2
	.dbline 1342
;       return;
	rjmp L199
L209:
	.dbline 1344
;     }
;     else if ((InByte == BROADCASTDEVTYPE) || (InByte == BROADCAST))
	lds R2,L200
	mov R24,R2
	cpi R24,241
	breq L213
X57:
	cpi R24,255
	brne L211
X58:
L213:
	.dbline 1345
;     {
	.dbline 1346
;       NET_UCSRA &= ~(1<<MPCM);
	cbi 0xb,0
	.dbline 1347
;       State = QTE;
	ldi R24,1
	sts L204,R24
	.dbline 1348
;       NetBroadCast = TRUE;
	sts _NetBroadCast,R24
	.dbline 1349
;       return;
	rjmp L199
L211:
	.dbline 1352
;     }     
;     else
;     {
	.dbline 1353
;       NET_UCSRA |= (1<<MPCM);
	sbi 0xb,0
	.dbline 1354
;       State = RESET;
	clr R2
	sts L204,R2
	.dbline 1355
;       NetBroadCast = FALSE;
	sts _NetBroadCast,R2
	.dbline 1356
;       return;
	rjmp L199
L207:
	.dbline 1360
;     }
;   }
; 
;   InByte = NET_UDR;
	in R2,0xc
	sts L200,R2
	.dbline 1362
; 
;   switch (State)
	lds R20,L204
	clr R21
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	breq L217
X59:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	breq L218
X60:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne X65
	rjmp L225
X65:
X61:
	rjmp L214
L217:
	.dbline 1365
;   {
;     case QTE :
;     CheckSum = 0;
	clr R2
	sts L202,R2
	.dbline 1366
;     Ptr = &NetRxData[0];
	ldi R24,<_NetRxData
	ldi R25,>_NetRxData
	sts L203+1,R25
	sts L203,R24
	.dbline 1367
;     Qte = InByte;
	lds R2,L200
	sts L201,R2
	.dbline 1368
;     State = DATA;
	ldi R24,2
	sts L204,R24
	.dbline 1369
;     break;
	rjmp L215
L218:
	.dbline 1372
; 
;     case DATA :
;     *Ptr = InByte;
	lds R2,L200
	lds R30,L203
	lds R31,L203+1
	std z+0,R2
	.dbline 1373
;     CheckSum = CheckSum + *Ptr++;
	lds R30,L203
	lds R31,L203+1
	ld R2,Z+
	sts L203+1,R31
	sts L203,R30
	lds R3,L202
	add R3,R2
	sts L202,R3
	.dbline 1374
;     if (Ptr >= &NetRxData[NET_RXBUFFER]-2) 
	ldi R24,<_NetRxData+10-2
	ldi R25,>_NetRxData+10-2
	cp R30,R24
	cpc R31,R25
	brlo L219
X62:
	.dbline 1375
;       {
	.dbline 1376
;         State = RESET;
	clr R2
	sts L204,R2
	.dbline 1377
;         NET_UCSRA |= (1<<MPCM);
	sbi 0xb,0
	.dbline 1378
;         break;
	rjmp L215
L219:
	.dbline 1380
;       }
;     Qte--;
	lds R24,L201
	subi R24,1
	sts L201,R24
	.dbline 1381
;     if (Qte == 0) State = CHECKSUM;
	tst R24
	brne L215
X63:
	.dbline 1381
	ldi R24,3
	sts L204,R24
	.dbline 1382
;     break;
	rjmp L215
L225:
	.dbline 1385
; 
;     case CHECKSUM :
;     if (InByte == CheckSum) TaskRegister(&NetAnalyseData,T1MS,FALSE);
	lds R2,L202
	lds R3,L200
	cp R3,R2
	brne L226
X64:
	.dbline 1385
	clr R2
	std y+0,R2
	ldi R18,10
	ldi R19,0
	ldi R16,<PL_NetAnalyseData
	ldi R17,>PL_NetAnalyseData
	rcall _TaskRegister
L226:
	.dbline 1386
;     *Ptr++ = 0x00;
	clr R2
	lds R30,L203
	lds R31,L203+1
	st Z+,R2
	sts L203+1,R31
	sts L203,R30
	.dbline 1387
;     State = RESET;
	sts L204,R2
	.dbline 1388
;     break;
	rjmp L215
L214:
	.dbline 1391
; 
;     default :
;     State = RESET;
	clr R2
	sts L204,R2
	.dbline 1392
;   }
L215:
	.dbline -2
L199:
	.dbline 0 ; func end
	adiw R28,1
	ld R21,y+
	ld R20,y+
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R21,y+
	ld R20,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.dbfunc e NetAnalyseData _NetAnalyseData fV
	.even
_NetAnalyseData::
	.dbline -1
	.dbline 1409
; }
; 
; /******************************************************************************
; 
; Name:     		void NetAnalyseData(void)
; 
; Description:  AnalyseData
; 
; Input:      	none
; 
; Output:     	none
; 
; Misc:
; 
; ******************************************************************************/
; void NetAnalyseData(void)
; {
	.dbline 1411
;   // Get Version
;   if (NetRxData[0] == 0xff)
	lds R24,_NetRxData
	cpi R24,255
	brne L229
X66:
	.dbline 1412
;   {
	.dbline 1413
;     NetWrite((uint)VERSION);
	ldi R16,101
	ldi R17,0
	rcall _NetWrite
	.dbline 1414
;   }
	rjmp L230
L229:
	.dbline 1417
;   
;   // Get Device
;   else if (NetRxData[0] == 0xfe)
	lds R24,_NetRxData
	cpi R24,254
	brne L231
X67:
	.dbline 1418
;   {
	.dbline 1419
;     NetWrite((uint)DEVICE);
	ldi R16,80
	ldi R17,0
	rcall _NetWrite
	.dbline 1420
;   }
	rjmp L232
L231:
	.dbline 1423
; 
;   // Force MCU Reset
;   else if ((NetRxData[0] == 0xf5) && (NetRxData[1] == 0x55)  && (NetRxData[2] == 0xaa))
	lds R24,_NetRxData
	cpi R24,245
	brne L233
X68:
	lds R24,_NetRxData+1
	cpi R24,85
	brne L233
X69:
	lds R24,_NetRxData+2
	cpi R24,170
	brne L233
X70:
	.dbline 1424
;   {
	.dbline 1425
;     NetWrite(0x55aa);
	ldi R16,21930
	ldi R17,85
	rcall _NetWrite
	.dbline 1426
;     TaskStop();
	rcall _TaskStop
	.dbline 1427
;     CLI();
	cli
L237:
	.dbline 1428
;     while(1); // Jam MCU, Kick by watch dog and Reset in bootstrap!!!
L238:
	.dbline 1428
	rjmp L237
L233:
	.dbline 1432
;   }
; 
;   // Write to EEprom location NetRxData[2], value NetRxData[3]
;   else if ((NetRxData[0] == 0xf0) && (NetRxData[1] == 0x55))
	lds R24,_NetRxData
	cpi R24,240
	brne L240
X71:
	lds R24,_NetRxData+1
	cpi R24,85
	brne L240
X72:
	.dbline 1433
;   {
	.dbline 1434
;     NetWrite(0x55aa);
	ldi R16,21930
	ldi R17,85
	rcall _NetWrite
	.dbline 1435
;     EEPROMwrite(NetRxData[2],NetRxData[3]);
	lds R18,_NetRxData+3
	lds R16,_NetRxData+2
	clr R17
	rcall _EEPROMwrite
	.dbline 1436
;   }
	rjmp L241
L240:
	.dbline 1439
; 
;   // Read EEprom location NetRxData[2]
;   else if ((NetRxData[0] == 0xf1) && (NetRxData[1] == 0x55))
	lds R24,_NetRxData
	cpi R24,241
	brne L245
X73:
	lds R24,_NetRxData+1
	cpi R24,85
	brne L245
X74:
	.dbline 1440
;   {
	.dbline 1441
;     NetWrite((int)EEPROMread(NetRxData[2])*10);
	lds R16,_NetRxData+2
	clr R17
	rcall _EEPROMread
	mov R18,R16
	clr R19
	ldi R16,10
	ldi R17,0
	rcall empy16s
	rcall _NetWrite
	.dbline 1442
;   }
	rjmp L246
L245:
	.dbline 1445
; 
;   // Get Temp
;   else if (NetRxData[0] == 0x20) NetWrite(Temp);
	lds R24,_NetRxData
	cpi R24,32
	brne L249
X75:
	.dbline 1445
	lds R16,_Temp
	lds R17,_Temp+1
	rcall _NetWrite
	rjmp L250
L249:
	.dbline 1448
; 
;   // Get Hum
;   else if (NetRxData[0] == 0x21) NetWrite(Hum);
	lds R24,_NetRxData
	cpi R24,33
	brne L251
X76:
	.dbline 1448
	lds R16,_Hum
	lds R17,_Hum+1
	rcall _NetWrite
	rjmp L252
L251:
	.dbline 1451
; 
;   // Get Pres
;   else if (NetRxData[0] == 0x22) NetWrite(Pres);
	lds R24,_NetRxData
	cpi R24,34
	brne L253
X77:
	.dbline 1451
	lds R16,_Pres
	lds R17,_Pres+1
	rcall _NetWrite
L253:
L252:
L250:
L246:
L241:
L234:
L232:
L230:
	.dbline -2
L228:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e NetWrite _NetWrite fV
;          Value -> R16,R17
	.even
_NetWrite::
	.dbline -1
	.dbline 1468
; }
; 
; /******************************************************************************
; 
; Name:         void NetWrite(int Value)
; 
; Description:  This function write a int in the TX buffer
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; void NetWrite(int Value)
; {
	.dbline 1469
;   if (NetBroadCast == TRUE) return;
	lds R24,_NetBroadCast
	cpi R24,1
	brne L256
X78:
	.dbline 1469
	rjmp L255
L256:
	.dbline 1471
; 
;   NetTxData[0] = 0x02;
	ldi R24,2
	sts _NetTxData,R24
	.dbline 1472
;   NetTxData[1] = (ushort)Value;
	sts _NetTxData+1,R16
	.dbline 1473
;   NetTxData[2] = (ushort)(Value>>8);
	movw R2,R16
	mov R2,R3
	clr R3
	sbrc R2,7
	com R3
	sts _NetTxData+2,R2
	.dbline 1474
;   NetTxData[3] = NetTxData[1] + NetTxData[2];
	mov R3,R16
	add R3,R2
	sts _NetTxData+3,R3
	.dbline 1475
;   NetTxQte = 4;
	ldi R24,4
	sts _NetTxQte,R24
	.dbline 1476
;   NetTxPtr = &NetTxData[0];
	ldi R24,<_NetTxData
	ldi R25,>_NetTxData
	sts _NetTxPtr+1,R25
	sts _NetTxPtr,R24
	.dbline 1478
; 
;   NET_UCSRB |= (1<<UDRIE);
	sbi 0xa,5
	.dbline -2
L255:
	.dbline 0 ; func end
	ret
	.dbsym r Value 16 I
	.dbend
	.area vector(rom, abs)
	.org 24
	rjmp _NetTxByte
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbfunc e NetTxByte _NetTxByte fV
	.even
_NetTxByte::
	st -y,R2
	st -y,R24
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 1497
; }
; 
; /******************************************************************************
; 
; Name:         void NetTxByte(void)
; 
; Description:  This function is automaticaly called each
;               time a char had been send on the NET bus.
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler NetTxByte:13
; void NetTxByte(void)
; {
	.dbline 1498
;   if (NetTxQte)
	lds R2,_NetTxQte
	tst R2
	breq L264
X79:
	.dbline 1499
;   {
	.dbline 1500
;     NET_PORT |= NET_TXE;          // Switch NET in Tx mode
	sbi 0x12,2
	.dbline 1501
;     NET_UDR = *NetTxPtr++;
	lds R30,_NetTxPtr
	lds R31,_NetTxPtr+1
	ld R2,Z+
	sts _NetTxPtr+1,R31
	sts _NetTxPtr,R30
	out 0xc,R2
	.dbline 1502
;     NetTxQte--;
	lds R24,_NetTxQte
	subi R24,1
	sts _NetTxQte,R24
	.dbline 1503
;   }
	rjmp L265
L264:
	.dbline 1504
;   else NET_UCSRB &= ~(1<<UDRIE);  /* TX int empty disable */
	cbi 0xa,5
L265:
	.dbline -2
L263:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R24,y+
	ld R2,y+
	reti
	.dbend
	.area vector(rom, abs)
	.org 26
	rjmp _NetTxFinish
	.area text(rom, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
	.dbfunc e NetTxFinish _NetTxFinish fV
	.even
_NetTxFinish::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 1523
; }
; 
; /******************************************************************************
; 
; Name:         void NetTxFinish(void)
; 
; Description:  This function is automaticaly called when
;               all TxBuffer had been transmited
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler NetTxFinish:14
; void NetTxFinish(void)
; {
	.dbline 1524
;   NET_PORT &= ~NET_TXE;     // Switch NET in Rx mode
	cbi 0x12,2
	.dbline -2
L266:
	.dbline 0 ; func end
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	reti
	.dbend
	.dbfunc e NetGetAddress _NetGetAddress fV
	.even
_NetGetAddress::
	.dbline -1
	.dbline 1542
; }
; 
; /******************************************************************************
; 
; Name:     		void NetGetAddress(void)
; 
; Description:  Get the network address of this node
; 							from dip switch
; 
; Input:      	None
; 
; Output:     	None
; 
; Misc:
; 
; ******************************************************************************/
; void NetGetAddress(void)
; {
	.dbline 1543
; 	NetAddress = NET_GET_ADDRESS;
	in R24,0x13
	andi R24,63
	subi R24,192    ; addi 64
	sts _NetAddress,R24
	.dbline 1543
	.dbline -2
L267:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\NetBarometer\Code9Bit\NetBarometer.c
_Humidity::
	.blkb 4
	.dbsym e Humidity _Humidity D
_Temperature::
	.blkb 4
	.dbsym e Temperature _Temperature D
_BaroTemp::
	.blkb 4
	.dbsym e BaroTemp _BaroTemp D
_Pressure::
	.blkb 4
	.dbsym e Pressure _Pressure D
_Pres::
	.blkb 2
	.dbsym e Pres _Pres i
_Hum::
	.blkb 2
	.dbsym e Hum _Hum i
_Temp::
	.blkb 2
	.dbsym e Temp _Temp i
_fc::
	.blkb 12
	.dbsym e fc _fc A[12:6]i
_NetNextFunction::
	.blkb 2
	.dbsym e NetNextFunction _NetNextFunction pfV
_NetNextEventTime::
	.blkb 1
	.dbsym e NetNextEventTime _NetNextEventTime c
_NetTxQte::
	.blkb 1
	.dbsym e NetTxQte _NetTxQte C
_NetTxPtr::
	.blkb 2
	.dbsym e NetTxPtr _NetTxPtr pc
_NetTxData::
	.blkb 10
	.dbsym e NetTxData _NetTxData A[10:10]c
_NetRxData::
	.blkb 10
	.dbsym e NetRxData _NetRxData A[10:10]c
_NetAddress::
	.blkb 1
	.dbsym e NetAddress _NetAddress c
	.area lit(rom, con, rel)
L124:
	.word 0x0,0x4348
L123:
	.word 0x0,0x4248
L121:
	.word 0x0,0x437a
L120:
	.word 0x0,0x4200
L119:
	.word 0x0,0x4680
L118:
	.word 0x0,0x45e0
L117:
	.word 0x0,0x4480
L116:
	.word 0x0,0x46c0
L114:
	.word 0x0,0x4580
L113:
	.word 0x0,0x4400
L112:
	.word 0x0,0x4080
L109:
	.word 0x0,0x469e
L108:
	.word 0x0,0x4100
L105:
	.word 0x5000,0x447d
L104:
	.word 0x0,0x4120
L88:
	.word 0x0,0x4120
L81:
	.word 0xcccd,0x3dcc
L80:
	.word 0xcccd,0x3dcc
L77:
	.word 0x0,0x42c8
L74:
	.word 0x0,0x41c8
L73:
	.word 0x6666,0x421e
L72:
	.word 0xd70a,0x3c23
L71:
	.word 0xc5ac,0x38a7
L70:
	.word 0xd70a,0x3c23
L69:
	.word 0xe7a2,0xb63b
L68:
	.word 0xe354,0x3d25
L67:
	.word 0x0,0xc080
; }
	.area  func_lit
PL_NetAnalyseData:	.word `_NetAnalyseData
PL_LEDFlash:	.word `_LEDFlash
